%define _with_repolib 1
%define _with_javadoc 0

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define full_version %{version}-patch-01

%define repodirbase %{_javadir}/repository.jboss.com/
%define repodirmvn  %{repodirbase}/maven2-brew/
%define repodir     %{repodirbase}/apache-cxf/%{full_version}-brew
%define repodirlib  %{repodir}/lib
%define repodirsrc  %{repodir}/src

%define groupId org.apache.cxf

Name:           apache-cxf
Version:        2.2.12
Release:        3.patch_01%{?dist}
Summary:        Apache CXF Open Source Service Framework

Group:          Development/Libraries
License:        ASL 2.0
URL:            http://cxf.apache.org
# svn export http://anonsvn.jboss.org/repos/jbossws/thirdparty/cxf/tags/cxf-2.2.12-patch-01/ apache-cxf-2.2.12-patch-01
# tar -jcf apache-cxf-2.2.12-patch-01.tar.bz2 apache-cxf-2.2.12-patch-01/
Source0:        apache-cxf-2.2.12-patch-01.tar.bz2
Source1:        apache-cxf-jpp-depmap.xml
Source2:        apache-cxf-component-info.xml

# Script from <pgier@redhat.com> that generates checksums
Source4: generate-maven-checksums

# ActiveMQ is just used for testing code and examples
# (we use JBoss Messaging at run-time)
# We need packages for activemq and activeio 
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/activemq-core/5.4.1/
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/activemq-parent/5.4.1/
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/kahadb/5.4.1/
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/protobuf/activemq-protobuf/1.1/
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/protobuf/activemq-protobuf-pom/1.1/
# cd repo2.maven.org/maven2
# tar czf ../../../apache-cxf-activemq-5.4.1.tgz org
# cd ../..
# rm -fr repo2.maven.org
Source13: apache-cxf-activemq-5.4.1.tgz
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/activeio-core/3.1.2/
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/activemq/activeio-parent/3.1.2/
# cd repo2.maven.org/maven2
# tar czf ../../../apache-cxf-activeio-3.1.2.tgz org
# cd ../..
# rm -fr repo2.maven.org
Source15: apache-cxf-activeio-3.1.2.tgz
# We need a package for apache-xbean
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/xbean/xbean/3.5/
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/xbean/xbean-spring/3.5/
# cd repo2.maven.org/maven2
# tar czf ../../../apache-cxf-xbean-3.5.tgz org
# cd ../..
# rm -fr repo2.maven.org
Source16: apache-cxf-xbean-3.5.tgz
# We need a package for jasypt
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/jasypt/jasypt/1.6/
# cd repo2.maven.org/maven2
# tar czf ../../../apache-cxf-jasypt-1.6.tgz org
# cd ../..
# rm -fr repo2.maven.org
Source17: apache-cxf-jasypt-1.6.tgz
# We need a package for apache-servicemix
# wget ....
# wget -R index.html --no-parent -r -e robots=off -U mvn http://repo2.maven.org/maven2/org/apache/servicemix/specs/org.apache.servicemix.specs.jbi-api-1.0/1.3.0/
# cd repo2.maven.org/maven2
# tar czf ../../../apache-cxf-apache-servicemix.tgz org
# cd ../..
# rm -fr repo2.maven.org
Source14: apache-cxf-apache-servicemix.tgz

# Things we need to patch
Patch0:  %{name}-build.patch
# Patch needed to use jettison 1.1, we need to upgrade to 1.2
Patch2:  %{name}-jettison11.patch
# We need to upgrade wss4j to 1.5.10
Patch3:  %{name}-wss4j.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch: noarch

# Basic stuff
BuildRequires: jpackage-utils
BuildRequires: java
BuildRequires: zip
BuildRequires: java-devel

# Maven is actually called from an Ant script
# and then invokes Ant with 'antrun'
BuildRequires: ant >= 0:1.7.0
BuildRequires: ant-nodeps
BuildRequires: ant-trax
BuildRequires: ant-contrib

# Maven and its dependencies
BuildRequires: maven2
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-clean
BuildRequires: maven2-plugin-checkstyle
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-dependency
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-plugin
BuildRequires: maven2-plugin-pmd
BuildRequires: maven2-plugin-release
BuildRequires: maven2-plugin-remote-resources
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-site
BuildRequires: maven2-plugin-shade
BuildRequires: maven2-plugin-source
BuildRequires: maven2-plugin-war
BuildRequires: maven-doxia-sitetools
BuildRequires: maven-shared
BuildRequires: maven-shared-file-management
BuildRequires: maven-shared-reporting-impl
BuildRequires: maven-surefire
BuildRequires: maven-surefire-maven-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: maven-wagon
BuildRequires: plexus-archiver
BuildRequires: plexus-compiler
BuildRequires: plexus-containers-container-default
BuildRequires: plexus-i18n
BuildRequires: plexus-utils
BuildRequires: plexus-velocity
BuildRequires: mojo-maven2-plugin-jaxb2
BuildRequires: mojo-maven2-plugin-build-helper
BuildRequires: mojo-maven2-plugin-xmlbeans
BuildRequires: maven-artifact-resolver

BuildRequires: jdom
BuildRequires: pmd
BuildRequires: sun-fi
BuildRequires: checkstyle
BuildRequires: apache-jar-resource-bundle
BuildRequires: ws-commons-XmlSchema
BuildRequires: easymock-classextension2
BuildRequires: wstx
BuildRequires: wsdl4j16
BuildRequires: sun-saaj-1.3-impl
BuildRequires: sun-saaj-1.3-api
BuildRequires: geronimo-annotation-1.0-api
BuildRequires: geronimo-jaf-1.1-api
BuildRequires: geronimo-ws-metadata-2.0-api
BuildRequires: geronimo-stax-1.0-api
BuildRequires: geronimo-stax-1.0-api
BuildRequires: geronimo-j2ee-connector-1.5-api
BuildRequires: geronimo-javamail-1.4-api
BuildRequires: geronimo-servlet-2.5-api
BuildRequires: geronimo-jms-1.1-api
BuildRequires: sun-jaxws-2.1-api
BuildRequires: spring2-core
BuildRequires: spring2-beans
BuildRequires: spring2-context
BuildRequires: spring2-aop
BuildRequires: spring2-web
BuildRequires: spring2-jms
BuildRequires: spring2-test
BuildRequires: spring2-tx
BuildRequires: spring2-context-support
BuildRequires: aopalliance
BuildRequires: ws-jaxme
BuildRequires: ws-commons-neethi
BuildRequires: jra
# activemq needs activeio and j2ee-management 1.0 :-(
BuildRequires: geronimo-j2ee-management-1.0-api
BuildRequires: geronimo-j2ee-management-1.1-api
BuildRequires: icu4j
BuildRequires: jetty6-management
BuildRequires: junit
BuildRequires: velocity
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-pool
BuildRequires: xml-security
BuildRequires: tjws
BuildRequires: derby
BuildRequires: geronimo-ejb-3.0-api
# servicemix requires qname (and JAF 1.0.2 but we map it to 1.1)
BuildRequires: geronimo-qname-1.1-api
BuildRequires: httpunit
#BuildRequires: xbean
BuildRequires: codehaus-stax11-api
# servicemix requires qname (and JAF 1.0.2 but we map it to 1.1)
BuildRequires: geronimo-qname-1.1-api
# JSR311 is RESTful, which we can get from RESTEasy
BuildRequires: resteasy
# FIXME: Upgrade to jettison 1.2
BuildRequires: jettison
BuildRequires: apache-abdera-core 
BuildRequires: apache-abdera-parser 
BuildRequires: apache-abdera-extensions
BuildRequires: wss4j
BuildRequires: xalan-j2
BuildRequires: bouncycastle 
BuildRequires: geronimo-ejb-3.0-api
BuildRequires: aspectj
BuildRequires: httpunit
BuildRequires: nekohtml
BuildRequires: xmlbeans
BuildRequires: spring2-webmvc
BuildRequires: felix
BuildRequires: felix-maven2

Requires: jpackage-utils
Requires: java
Requires(post):       jpackage-utils
Requires(postun):     jpackage-utils

%description
A Open Source Service Framework

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
API documentation for %{name}.

%package src-zip
Summary:        Container for the sources for %{name}
Group:          Development

%description src-zip
Container for the sources for %{name}.

%if %{with_repolib}
%package         repolib
Summary:         Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name}-%{full_version}
# Delete jars
find -name "*.jar" -type f | xargs -t %{__rm} -f
%patch0
%patch2 -p0
%patch3 -p0

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir -p $MAVEN_REPO_LOCAL
# Add any artifacts we cannot download to local repository
pushd $MAVEN_REPO_LOCAL
# We need packages for activemq, activeio and jasypt
tar xzf %{SOURCE13}
tar xzf %{SOURCE15}
# We need a package for apache-servicemix
tar xzf %{SOURCE14}
# We need a package for apache-xbean
tar xzf %{SOURCE16}
# We need a package for 
tar xzf %{SOURCE17}
popd

mvn-jpp \
        -e \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        -Pnochecks \
        install javadoc:javadoc

%install
rm -rf %{buildroot}

# JARs and POMs
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

for artifactId in \
                  cxf-api \
                  cxf-common-schemas \
                  cxf-common-utilities \
                  cxf-rt-bindings-coloc \
                  cxf-rt-bindings-corba \
                  cxf-rt-bindings-http \
                  cxf-rt-bindings-object \
                  cxf-rt-bindings-soap \
                  cxf-rt-bindings-xml \
                  cxf-rt-core \
                  cxf-rt-databinding-aegis \
                  cxf-rt-databinding-jaxb \
                  cxf-rt-frontend-jaxrs \
                  cxf-rt-frontend-jaxws \
                  cxf-rt-frontend-simple \
                  cxf-rt-javascript \
                  cxf-rt-management \
                  cxf-rt-transports-http \
                  cxf-rt-transports-http-jetty \
                  cxf-rt-transports-jms \
                  cxf-rt-transports-local \
                  cxf-rt-ws-addr \
                  cxf-rt-ws-policy \
                  cxf-rt-ws-rm \
                  cxf-rt-ws-security \
                  cxf-tools-common \
                  cxf-tools-java2ws \
                  cxf-tools-validator \
                  cxf-tools-wsdlto-core \
                  cxf-tools-wsdlto-databinding-jaxb \
                  cxf-tools-wsdlto-frontend-jaxws \
                  cxf-xjc-dv \
                  cxf-xjc-ts \
                                   ; do
install -pm 644 \
   .m2/repository/org/apache/cxf/${artifactId}/%{full_version}/${artifactId}-%{full_version}.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/${artifactId}-%{full_version}.jar
install -pm 644 \
   .m2/repository/org/apache/cxf/${artifactId}/%{full_version}/${artifactId}-%{full_version}.pom \
   $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-${artifactId}.pom
%add_to_maven_depmap %{groupId} ${artifactId} %{full_version} JPP/%{name} ${artifactId}
done
# Create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{full_version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{full_version}||g"`; done)

for artifactId in \
                  cxf-xjc-boolean \
                  cxf-xjc-bug671 \
                                   ; do
install -pm 644 \
   .m2/repository/org/apache/cxf/xjcplugins/${artifactId}/%{full_version}/${artifactId}-%{full_version}.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/${artifactId}-%{full_version}.jar
install -pm 644 \
   .m2/repository/org/apache/cxf/xjcplugins/${artifactId}/%{full_version}/${artifactId}-%{full_version}.pom \
   $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-${artifactId}.pom
%add_to_maven_depmap %{groupId}.xjcplugins ${artifactId} %{full_version} JPP/%{name} ${artifactId}
done
# Create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{full_version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{full_version}||g"`; done)

# Only POMs
install -pm 644 \
   .m2/repository/org/apache/cxf/cxf/%{full_version}/cxf-%{full_version}.pom \
   $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-cxf.pom
%add_to_maven_depmap %{groupId} cxf %{full_version} JPP/%{name} cxf
install -pm 644 \
   .m2/repository/org/apache/cxf/cxf-parent/%{full_version}/cxf-parent-%{full_version}.pom \
   $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-cxf-parent.pom
%add_to_maven_depmap %{groupId} cxf-parent %{full_version} JPP/%{name} cxf-parent 

# Copy the ZIPs
install -d -m 755 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev
pushd /tmp
tar xjf %{SOURCE0}
zip -q -r apache-cxf-src.zip %{name}-%{full_version}
popd
install -m 644 /tmp/apache-cxf-src.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/%{name}-%{full_version}-src.zip

# TODO: Create a full repolib subpackage
%if %{with_repolib}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirmvn}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirmvn}/org
        install -d -m 755 $RPM_BUILD_ROOT%{repodirmvn}/org/apache
cp -pr .m2/repository/org/apache/cxf $RPM_BUILD_ROOT%{repodirmvn}/org/apache
# Don't upload the following ones
rm -fr $RPM_BUILD_ROOT%{repodirmvn}/org/apache/cxf/cxf-anttasks
rm -fr $RPM_BUILD_ROOT%{repodirmvn}/org/apache/cxf/cxf/2.1.5
rm -fr $RPM_BUILD_ROOT%{repodirmvn}/org/apache/cxf/cxf-parent/2.1.5

# Replace markers in component-info.xml
sed -i 's/@VERSION@/%{full_version}-brew/g' %{SOURCE2}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}

# Now for the legacy buildmagic repo
        install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{PATCH3} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        find $RPM_BUILD_ROOT%{repodirmvn}/org/apache -name '*.jar' \
             -exec cp -p {} $RPM_BUILD_ROOT%{repodirlib} \;
        find $RPM_BUILD_ROOT%{repodirmvn}/org/apache -name '*.pom' \
             -exec cp -p {} $RPM_BUILD_ROOT%{repodirlib} \;
# Generate the checksums for the ones in the maven repo
cp %{SOURCE4} .
./generate-maven-checksums $RPM_BUILD_ROOT%{repodirmvn}/org/apache
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_javadir}*/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
#%{_javadocdir}/%{name}-%{version}
#%{_javadocdir}/%{name}

%files src-zip
%defattr(-, root, root, -)
%{_javadir}*/jbossas-fordev/%{name}-%{full_version}-src.zip

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Apr 1 2011 Yiqiao Wang <yiwang@redhat.com> 2.2.12-3.patch_01
- Remove R: maven2

* Wed Feb 23 2011 Hui Wang <huwang@redhat.com> 2.2.12-2.patch_01
- Remove parent-pom.patch

* Fri Feb 18 2011 Hui Wang <huwang@redhat.com> 2.2.12-1.patch_01
- Upgrade to 2.2.12-patch-01
- License is ASL 2.0
- Cleanups

* Mon Nov 15 2010 Martha Benitez <mbenitez@redhat.com> - 2.2.6-1-patch_01.8
- Build with maven 2.2.1
- Change BR maven-artifact-resolver to maven-shared-artifact-resolver
- Add BR jdom, icu4j, glassfish-jaxws, plexus-containers, codehaus-stax11-api, httpunit
- Add extra memory parameters
- Add patches to include new method from maven-shade-plugin
- Add patches to include maven-artifact, maven-model, plexus-plugin, plexus-containers as explicit dependencies
- Add condition to build javadoc sub-package

* Fri Aug 06 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.7
- Fix unversioned file names

* Thu Aug 05 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.6
- Refresh sources -- Spring removal not to be included

* Wed Aug 04 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.5
- Include changes to remove Spring from tools

* Wed Aug 04 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.4
- Upgrade to new tag and revert to patch-01 versioning

* Fri Jul 30 2010 Yiqiao Wang <yiwang@redhat.com> - 2.2.6-1-patch_02.1
- Add patch for JBPAPP-4761
- Change the way version and full_version work

* Mon Jun 14 2010 Yiqiao Wang <yiwang@redhat.com> - 2.2.6-1-patch_01.3
- Merge from RHEL4 (upgrade to 2.2.6)

* Mon Jun 14 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.3
- Fix for CVE-2010-2076

* Tue May 18 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.2
- Add cxf-xjc-boolean and cxf-xjc-bug671 artifacts

* Mon May 17 2010 Fernando Nasser <fnasser@redhat.com> - 2.2.6-1-patch_01.1
- Upgrade to 2.2.6
- Fix for CVE-2010-2076

* Sat Feb 20 2010 Yong Yang <yyang@redhat.com> - 2.2.2-9.1
- Add depmap for asm-all

* Tue Dec 15 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-9
- Fix component-info
- Adjust depmap for newer stax-api groupId

* Fri Dec 11 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-8
- Add signatures to the maven repo contents
- Fix copying of .jar and .pom files to the repolib

* Thu Dec 10 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-7
- Add buildmagic part to repolib

* Thu Oct 29 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-6
- Use mojo-maven2-plugin-xmlbeans package

* Fri Oct 23 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-5
- Build from sources

* Fri Oct 23 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-4
- Fix POM file names

* Fri Oct 23 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-3
- Fix depmap fragments and install the right file as cxf-parent.pom

* Fri Oct 23 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-2
- Fix depmap fragments

* Thu Oct 22 2009 Fernando Nasser <fnasser@redhat.com> - 2.2.2-1
- First RPM release
